var NAVTREE =
[
  [ "libvpb", "index.html", [
    [ "Main Page", "index.html", null ],
    [ "Related Pages", "pages.html", [
      [ "Tone detection", "ToneDetect.html", null ],
      [ "Utility programs", "VPBUtils.html", null ],
      [ "Environment variables", "VPBenv.html", null ],
      [ "Configuration files", "VPBconf.html", null ],
      [ "Localisation", "L10N.html", null ],
      [ "Credits", "Credits.html", null ],
      [ "Todo List", "todo.html", null ],
      [ "Deprecated List", "deprecated.html", null ]
    ] ],
    [ "Modules", "modules.html", [
      [ "Public API functions", "group__PublicAPI.html", [
        [ "Queue size", "group__QueueSize.html", null ],
        [ "Port initialisation", "group__PortInit.html", null ],
        [ "Card information", "group__CardInfo.html", null ],
        [ "Port control", "group__PortControl.html", null ],
        [ "Event handling", "group__Events.html", null ],
        [ "Audio play and record", "group__Audio.html", null ],
        [ "Error handling", "group__ErrorHandling.html", null ],
        [ "Dialling", "group__Dialling.html", null ],
        [ "Programmable tone generator", "group__ToneGen.html", null ],
        [ "Programmable tone detector", "group__ToneDet.html", null ],
        [ "Timer functions", "group__Timers.html", null ],
        [ "Locale selection", "group__I18N.html", null ],
        [ "Wav audio support", "group__WavAudio.html", null ],
        [ "DTMF digit collection", "group__DTMFCollect.html", null ],
        [ "Caller id", "group__CID.html", [
          [ "Caller id decoding", "group__CIDDecode.html", null ],
          [ "Caller id generation", "group__CIDGen.html", null ],
          [ "Japanese caller id", "group__CIDDecodeJP.html", null ]
        ] ],
        [ "Call logging and monitoring", "group__CallLogging.html", null ],
        [ "Echo cancelling", "group__EchoCan.html", null ],
        [ "Loop voltage sensing", "group__LoopVolt.html", null ],
        [ "ISDN support", "group__ISDN.html", null ]
      ] ],
      [ "Internal API functions", "group__InternalAPI.html", [
        [ "Miscellaneous functions", "group__InternalAPIfunc.html", null ],
        [ "Audio playback and recording", "group__InternalPlayRec.html", null ],
        [ "Hardware registry", "group__VPBRegistry.html", null ],
        [ "VTCore HostDSP implementation", "group__VTCoreAPI.html", null ]
      ] ],
      [ "Internal implementation detail", "group__InternalImpl.html", [
        [ "Audio playback and recording implementation", "group__PlayRecImpl.html", null ],
        [ "VPBapi implementation detail", "group__VPBapiImpl.html", null ]
      ] ]
    ] ],
    [ "Class List", "annotated.html", [
      [ "ADPCM", "structADPCM.html", null ],
      [ "ADPCMCompression", "classADPCMCompression.html", null ],
      [ "AGCBOX", "structAGCBOX.html", null ],
      [ "ANA_IFACE", "structANA__IFACE.html", null ],
      [ "AU", "structAU.html", null ],
      [ "Audio", "structAudio.html", null ],
      [ "AUDIO_THREAD_MULTI", "structAUDIO__THREAD__MULTI.html", null ],
      [ "baseHipData", "classbaseHipData.html", null ],
      [ "ToneGen::Config::Cadence", "structToneGen_1_1Config_1_1Cadence.html", null ],
      [ "CALL", "structCALL.html", null ],
      [ "callhis", "structcallhis.html", null ],
      [ "CARD_LIST", "structCARD__LIST.html", null ],
      [ "COFF_FILE", "structCOFF__FILE.html", null ],
      [ "Comm", "classComm.html", null ],
      [ "Compression", "classCompression.html", null ],
      [ "CON_THREAD_INFO", "structCON__THREAD__INFO.html", null ],
      [ "CONF_INFO", "structCONF__INFO.html", null ],
      [ "ToneGen::Config", "classToneGen_1_1Config.html", null ],
      [ "Country", "structCountry.html", null ],
      [ "cref_info", "structcref__info.html", null ],
      [ "DATA", "structDATA.html", null ],
      [ "DchannelData", "structDchannelData.html", null ],
      [ "DigitCollect", "structDigitCollect.html", null ],
      [ "DTMF_DIGIT", "structDTMF__DIGIT.html", null ],
      [ "ERROR", "structERROR.html", null ],
      [ "ToneGen::Exception", "classToneGen_1_1Exception.html", null ],
      [ "FACT", "structFACT.html", null ],
      [ "Fifo", "classFifo.html", null ],
      [ "FILHEADER", "structFILHEADER.html", null ],
      [ "FMT", "structFMT.html", null ],
      [ "ToneGen::Config::Freq", "structToneGen_1_1Config_1_1Freq.html", null ],
      [ "GENERIC_CRITICAL_SECTION", "structGENERIC__CRITICAL__SECTION.html", null ],
      [ "Hip", "classHip.html", null ],
      [ "HipDataPCI", "classHipDataPCI.html", null ],
      [ "HostDSP", "classHostDSP.html", null ],
      [ "HostFifo", "classHostFifo.html", null ],
      [ "HostToneGen", "classHostToneGen.html", null ],
      [ "LinearCompression", "classLinearCompression.html", null ],
      [ "llc_cat", "structllc__cat.html", null ],
      [ "llc_list", "structllc__list.html", null ],
      [ "llc_var", "structllc__var.html", null ],
      [ "LogThread", "structLogThread.html", null ],
      [ "LOOPSENSE", "structLOOPSENSE.html", null ],
      [ "OBJS", "structOBJS.html", null ],
      [ "OL_CARD", "structOL__CARD.html", null ],
      [ "OL_INFO", "structOL__INFO.html", null ],
      [ "OP_CARD", "structOP__CARD.html", null ],
      [ "OP_INFO", "structOP__INFO.html", null ],
      [ "OpenPri", "classOpenPri.html", null ],
      [ "OPT_FILHEADER", "structOPT__FILHEADER.html", null ],
      [ "PCMCompression", "classPCMCompression.html", null ],
      [ "Play", "structPlay.html", null ],
      [ "PLAY_FILE_ASYNC_ARGS", "structPLAY__FILE__ASYNC__ARGS.html", null ],
      [ "pri_chan", "structpri__chan.html", null ],
      [ "PRI_IFACE", "structPRI__IFACE.html", null ],
      [ "Record", "structRecord.html", null ],
      [ "RECORD_FILE_ASYNC_ARGS", "structRECORD__FILE__ASYNC__ARGS.html", null ],
      [ "ScopedMutex", "classScopedMutex.html", null ],
      [ "SECTION_HEADER", "structSECTION__HEADER.html", null ],
      [ "soft_bridge_info", "structsoft__bridge__info.html", null ],
      [ "SYMBOL_ENTRY", "structSYMBOL__ENTRY.html", null ],
      [ "Timer", "classTimer.html", null ],
      [ "TMRS", "structTMRS.html", null ],
      [ "TONE", "structTONE.html", null ],
      [ "TONE_INFO", "structTONE__INFO.html", null ],
      [ "ToneGen", "classToneGen.html", null ],
      [ "V4PCI_DSP", "classV4PCI__DSP.html", null ],
      [ "V4PCIDspFifo", "classV4PCIDspFifo.html", null ],
      [ "V4PCIToneGen", "classV4PCIToneGen.html", null ],
      [ "VLOG", "structVLOG.html", null ],
      [ "VOXCONFIG", "structVOXCONFIG.html", null ],
      [ "voxstate", "structvoxstate.html", null ],
      [ "VPB_CALL", "structVPB__CALL.html", null ],
      [ "VPB_CALL_INFO", "structVPB__CALL__INFO.html", null ],
      [ "VPB_CARD_INFO", "structVPB__CARD__INFO.html", null ],
      [ "VPB_CID", "structVPB__CID.html", null ],
      [ "VPB_CID_JP", "structVPB__CID__JP.html", null ],
      [ "VPB_DATA", "structVPB__DATA.html", null ],
      [ "VPB_DETECT", "structVPB__DETECT.html", null ],
      [ "VPB_DEV", "structVPB__DEV.html", null ],
      [ "VPB_DIGITS", "structVPB__DIGITS.html", null ],
      [ "VPB_EVENT", "structVPB__EVENT.html", null ],
      [ "VPB_PLAY", "structVPB__PLAY.html", null ],
      [ "VPB_RECORD", "structVPB__RECORD.html", null ],
      [ "VPB_STRAN", "structVPB__STRAN.html", null ],
      [ "VPB_TONE", "structVPB__TONE.html", null ],
      [ "VPB_TONE_MAP", "structVPB__TONE__MAP.html", null ],
      [ "VPB_VLOG", "structVPB__VLOG.html", null ],
      [ "VPB_VOX", "structVPB__VOX.html", null ],
      [ "VpbException", "classVpbException.html", null ],
      [ "VPBHANDLE", "structVPBHANDLE.html", null ],
      [ "VPBREG", "structVPBREG.html", null ],
      [ "VPBRegister", "classVPBRegister.html", null ],
      [ "VT_DATA", "structVT__DATA.html", null ],
      [ "VT_REG_RW", "structVT__REG__RW.html", null ],
      [ "VTCore", "classVTCore.html", null ],
      [ "VTCORE_CARD", "structVTCORE__CARD.html", null ],
      [ "vtcore_chan", "structvtcore__chan.html", null ],
      [ "VTCORE_INFO", "structVTCORE__INFO.html", null ],
      [ "WAVE", "structWAVE.html", null ],
      [ "WFILE", "structWFILE.html", null ],
      [ "Wobbly", "classWobbly.html", null ],
      [ "wrapper_s", "structwrapper__s.html", null ]
    ] ],
    [ "Class Index", "classes.html", null ],
    [ "Class Hierarchy", "hierarchy.html", [
      [ "ADPCM", "structADPCM.html", null ],
      [ "AGCBOX", "structAGCBOX.html", null ],
      [ "ANA_IFACE", "structANA__IFACE.html", null ],
      [ "AU", "structAU.html", null ],
      [ "Audio", "structAudio.html", [
        [ "Play", "structPlay.html", null ],
        [ "Record", "structRecord.html", null ]
      ] ],
      [ "AUDIO_THREAD_MULTI", "structAUDIO__THREAD__MULTI.html", null ],
      [ "baseHipData", "classbaseHipData.html", [
        [ "HipDataPCI", "classHipDataPCI.html", null ],
        [ "HipDataPCI", "classHipDataPCI.html", null ]
      ] ],
      [ "ToneGen::Config::Cadence", "structToneGen_1_1Config_1_1Cadence.html", null ],
      [ "CALL", "structCALL.html", null ],
      [ "callhis", "structcallhis.html", null ],
      [ "CARD_LIST", "structCARD__LIST.html", null ],
      [ "COFF_FILE", "structCOFF__FILE.html", null ],
      [ "Comm", "classComm.html", null ],
      [ "Compression", "classCompression.html", [
        [ "ADPCMCompression", "classADPCMCompression.html", null ],
        [ "LinearCompression", "classLinearCompression.html", null ],
        [ "PCMCompression", "classPCMCompression.html", null ]
      ] ],
      [ "CON_THREAD_INFO", "structCON__THREAD__INFO.html", null ],
      [ "CONF_INFO", "structCONF__INFO.html", null ],
      [ "ToneGen::Config", "classToneGen_1_1Config.html", null ],
      [ "Country", "structCountry.html", null ],
      [ "cref_info", "structcref__info.html", null ],
      [ "DATA", "structDATA.html", null ],
      [ "DchannelData", "structDchannelData.html", null ],
      [ "DigitCollect", "structDigitCollect.html", null ],
      [ "DTMF_DIGIT", "structDTMF__DIGIT.html", null ],
      [ "ERROR", "structERROR.html", null ],
      [ "ToneGen::Exception", "classToneGen_1_1Exception.html", null ],
      [ "FACT", "structFACT.html", null ],
      [ "Fifo", "classFifo.html", [
        [ "HostFifo", "classHostFifo.html", null ],
        [ "V4PCIDspFifo", "classV4PCIDspFifo.html", null ]
      ] ],
      [ "FILHEADER", "structFILHEADER.html", null ],
      [ "FMT", "structFMT.html", null ],
      [ "ToneGen::Config::Freq", "structToneGen_1_1Config_1_1Freq.html", null ],
      [ "GENERIC_CRITICAL_SECTION", "structGENERIC__CRITICAL__SECTION.html", null ],
      [ "Hip", "classHip.html", null ],
      [ "HostDSP", "classHostDSP.html", [
        [ "OpenPri", "classOpenPri.html", null ],
        [ "V4PCI_DSP", "classV4PCI__DSP.html", null ],
        [ "VTCore", "classVTCore.html", null ]
      ] ],
      [ "llc_cat", "structllc__cat.html", null ],
      [ "llc_list", "structllc__list.html", null ],
      [ "llc_var", "structllc__var.html", null ],
      [ "LogThread", "structLogThread.html", null ],
      [ "LOOPSENSE", "structLOOPSENSE.html", null ],
      [ "OBJS", "structOBJS.html", null ],
      [ "OL_CARD", "structOL__CARD.html", null ],
      [ "OL_INFO", "structOL__INFO.html", null ],
      [ "OP_CARD", "structOP__CARD.html", null ],
      [ "OP_INFO", "structOP__INFO.html", null ],
      [ "OPT_FILHEADER", "structOPT__FILHEADER.html", null ],
      [ "PLAY_FILE_ASYNC_ARGS", "structPLAY__FILE__ASYNC__ARGS.html", null ],
      [ "pri_chan", "structpri__chan.html", null ],
      [ "PRI_IFACE", "structPRI__IFACE.html", null ],
      [ "RECORD_FILE_ASYNC_ARGS", "structRECORD__FILE__ASYNC__ARGS.html", null ],
      [ "ScopedMutex", "classScopedMutex.html", null ],
      [ "SECTION_HEADER", "structSECTION__HEADER.html", null ],
      [ "soft_bridge_info", "structsoft__bridge__info.html", null ],
      [ "SYMBOL_ENTRY", "structSYMBOL__ENTRY.html", null ],
      [ "Timer", "classTimer.html", null ],
      [ "TMRS", "structTMRS.html", null ],
      [ "TONE", "structTONE.html", null ],
      [ "TONE_INFO", "structTONE__INFO.html", null ],
      [ "ToneGen", "classToneGen.html", [
        [ "HostToneGen", "classHostToneGen.html", null ],
        [ "V4PCIToneGen", "classV4PCIToneGen.html", null ]
      ] ],
      [ "VLOG", "structVLOG.html", null ],
      [ "VOXCONFIG", "structVOXCONFIG.html", null ],
      [ "voxstate", "structvoxstate.html", null ],
      [ "VPB_CALL", "structVPB__CALL.html", null ],
      [ "VPB_CALL_INFO", "structVPB__CALL__INFO.html", null ],
      [ "VPB_CARD_INFO", "structVPB__CARD__INFO.html", null ],
      [ "VPB_CID", "structVPB__CID.html", null ],
      [ "VPB_CID_JP", "structVPB__CID__JP.html", null ],
      [ "VPB_DATA", "structVPB__DATA.html", null ],
      [ "VPB_DETECT", "structVPB__DETECT.html", null ],
      [ "VPB_DEV", "structVPB__DEV.html", null ],
      [ "VPB_DIGITS", "structVPB__DIGITS.html", null ],
      [ "VPB_EVENT", "structVPB__EVENT.html", null ],
      [ "VPB_PLAY", "structVPB__PLAY.html", null ],
      [ "VPB_RECORD", "structVPB__RECORD.html", null ],
      [ "VPB_STRAN", "structVPB__STRAN.html", null ],
      [ "VPB_TONE", "structVPB__TONE.html", null ],
      [ "VPB_TONE_MAP", "structVPB__TONE__MAP.html", null ],
      [ "VPB_VLOG", "structVPB__VLOG.html", null ],
      [ "VPB_VOX", "structVPB__VOX.html", null ],
      [ "VpbException", "classVpbException.html", null ],
      [ "VPBHANDLE", "structVPBHANDLE.html", null ],
      [ "VPBREG", "structVPBREG.html", null ],
      [ "VPBRegister", "classVPBRegister.html", null ],
      [ "VT_DATA", "structVT__DATA.html", null ],
      [ "VT_REG_RW", "structVT__REG__RW.html", null ],
      [ "VTCORE_CARD", "structVTCORE__CARD.html", null ],
      [ "vtcore_chan", "structvtcore__chan.html", null ],
      [ "VTCORE_INFO", "structVTCORE__INFO.html", null ],
      [ "WAVE", "structWAVE.html", null ],
      [ "WFILE", "structWFILE.html", null ],
      [ "Wobbly", "classWobbly.html", null ],
      [ "wrapper_s", "structwrapper__s.html", null ]
    ] ],
    [ "Class Members", "functions.html", null ],
    [ "File List", "files.html", [
      [ "apifunc.h", "apifunc_8h.html", null ],
      [ "playrec.h", "playrec_8h.html", null ],
      [ "tonegen.h", "tonegen_8h.html", null ],
      [ "vpbapi.h", "vpbapi_8h.html", null ],
      [ "vpbreg.h", "vpbreg_8h.html", null ],
      [ "vt_deprecated.h", "vt__deprecated_8h.html", null ],
      [ "vtcore.h", "vtcore_8h.html", null ]
    ] ],
    [ "Directories", "dirs.html", [
      [ "include", "dir_fbcf23e7f4f5dd66e2b14f5b5e3d485b.html", [
        [ "vt", "dir_02b30cc7cc7adb089467c9bad7b3f22a.html", null ]
      ] ],
      [ "src", "dir_3d6beafedc99ad34715bcba4aff3d125.html", [
        [ "libvpb", "dir_1669cb4a3377a5ed4661618d4fa83550.html", [
          [ "doc", "dir_bb8101f14b302a28a3d1787680998123.html", null ]
        ] ]
      ] ]
    ] ],
    [ "File Members", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

